//
//  ElisController.h
//  Elis Colors
//
//  Created by 柳 on 09/09/12.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

// Elisの一番たいせつなコントローラ。
// ElisLayerへのアクセスはここを経由して。(KVO以外)

// もう一段モデルを噛ませたほうがよかったなあといまさら。

#import <Cocoa/Cocoa.h>
#import "ElisBase.h"
#import "ElisMedia.h"
#import "ElisLayer.h"
#import "ElisAnimationLayerFactory.h"
#import "ElisTimeLineController.h"
#import "ElisCustomFilter.h"
#import "ElisWriter.h"

@class ElisMainView, ElisTimeLineController, ElisPropertyTableController;

CGRect ProjectMovieSize;
QTTime globalCurrentTime;
BOOL recording;
int timeLineXShift;

@interface ElisController : NSObject {
    NSMutableArray* layers;  // 全てのレイヤーはここに束縛
    IBOutlet ElisMainView* _mainView;
    ElisAnimationLayerFactory* _animationLayerFactory;
    IBOutlet ElisTimeLineController* _timeLineController;
    IBOutlet ElisPropertyTableController* _tableController;
    IBOutlet NSWindow* _mainWindow;
    IBOutlet ElisWriter* _writer;
    
    float hipTime;
    QTTime _currentTime;
    BOOL playing; // YES = 再生中
    NSGarbageCollector* collector; // GCの制御用。
    NSString* savePath;
    
    IBOutlet NSSlider* timeSlider;
    IBOutlet NSTextField* timeCodeField;
    
#ifdef __SNOW_LEOPARD_GCD__
    dispatch_queue_t diq;
#endif
}

- (float)getHipTime;

- (IBAction)startPlay:(id)sender;
- (IBAction)stopPlay:(id)sender;
- (IBAction)timeSliderChanged:(id)sender;
- (void)moveSliderTo:(QTTime)time;
- (void)refresh;
- (void)getSoundTrack:(NSMutableArray*)soundTrack;
- (IBAction)deleteSelectLayer:(id)sender;
- (IBAction)recordingStateChanged:(id)sender;
- (IBAction)removeAllKeyFrame:(id)sender;
- (IBAction)removeEffect:(id)sender;

- (IBAction)writeToFile:(id)sender;
- (IBAction)openProjectSaveDialog:(id)sender;
- (IBAction)openProjectLoadDialog:(id)sender;
- (IBAction)rewriteProject:(id)sender;

- (IBAction)changeToSmallWindiw:(id)sender;

@end
