//
//  ElisTimeLineController.h
//  Elis Colors
//
//  Created by 柳 on 09/09/12.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

// タイムラインのコントローラ兼モデル。Core Animation Layerを一括管理。

// MainControllerへの再描画の要求は手動で。

#import <Cocoa/Cocoa.h>
#import "ElisBase.h"
#import "ElisLayer.h"
//#import "ElisPropertyTableController.h"
#import "ElisAnimationLayerFactory.h"
#import "ElisPropertyTableController.h"

#define TRACK_MAX 16

#define STRETCH_RIGHT 1
#define STRETCH_LEFT 2

float timeLineScale;

@interface ElisTimeLineController : NSObject {
    CALayer* rootLayer, *timeLine, *playbackBar;
    IBOutlet id _timeLineView;
    IBOutlet id _mainController;
    IBOutlet id _tableController;
    CALayer* draggingLayer;
    
    NSPoint clickedPosition;
    CGPoint clickedLayerPosition;
    BOOL dragging;
    int stretch;
    
    ElisAnimationLayerFactory* _layerFactory;
}

- (IBAction)add:(id)sender; // テスト用
- (void)changeLayerPosition:(CALayer*)layer position:(NSPoint)point;
- (void)movePlaybackBar:(float)p;
- (void)clicked:(NSPoint)point;
- (void)dragging:(NSPoint)point;
- (BOOL)isInclude:(CALayer*)layer point:(NSPoint)point;
- (void)changeLayerPosition:(CALayer*)layer position:(NSPoint)point;
- (BOOL)canDeleteLayer;

@end
